#ifndef FIBERS_HPP
#define FIBERS_HPP

#include "../Context/context.hpp" // Assuming context.hpp defines the Context struct
#include <cstdint> // For uintptr_t

class Fiber {
private:
    Context context_{}; // Holds the context of the fiber
    void *data_; // Pointer to data passed to the fiber
    char *stack_bottom; // Stack memory for the fiber
    char *stack_top; // Stack memory for the fiber

public:
    Fiber(void (*function)(), void *data = nullptr);
    ~Fiber();

    Context *getContext();
    void *getData() const;
};

#endif // FIBERS_HPP
