#ifndef SCHEDULER_HPP
#define SCHEDULER_HPP

#include <deque>
#include "../Fibers/Fibers.hpp"
#include "../Context/context.hpp" // Assuming context.hpp defines `get_context`, `set_context`, and `swap_context`

class Scheduler {
private:
    std::deque<Fiber *> fibers_; // Queue of fibers to execute
    Context context_; // Context of the scheduler itself
    Fiber *current_fiber_; // Keep track of the currently running fiber

public:
    Scheduler();
    ~Scheduler();

    void spawn(Fiber *fiber);
    void do_it();
    void fiber_exit();
    void yield();
    void *getData();
};

#endif // SCHEDULER_HPP
