#include <iostream>
#include <deque>
#include "Context/context.hpp" // Assuming the provided context library is included here
#include "Scheduler/Scheduler.hpp"

//compile test with: g++ Fibers/Fibers.cpp Scheduler/Scheduler.cpp Test.cpp Context/context.o -o test_program

// Global scheduler instance
Scheduler scheduler;

// Example functions
void func1() {
    void *dp = scheduler.getData();
    if (dp) {
        std::cout << "fiber 1: " << *reinterpret_cast<int *>(dp) << std::endl;
        scheduler.yield();
        std::cout << "fiber 1 after yeild: " << *reinterpret_cast<int *>(dp) << std::endl;
        if (*reinterpret_cast<int *>(dp) >= 2){
            std::cout << "fiber 1: if statement called"<< std::endl;
        }
    }
    scheduler.fiber_exit();
}

void func2() {
    void *dp = scheduler.getData();
    if (dp) {
        std::cout << "fiber 2: " << *reinterpret_cast<int *>(dp) << std::endl;
        *reinterpret_cast<int *>(dp) += 1;  // Increment the data
    }
    scheduler.fiber_exit();
}

// Main function to demonstrate the scheduler
int main() {
    int d = 1;
    void *dp = &d; // Data pointer to be shared between fibers

    Fiber f1(func1, dp);  // func1 uses shared data
    Fiber f2(func2, dp);  // func2 uses shared data

    scheduler.spawn(&f1);
    scheduler.spawn(&f2);

    scheduler.do_it();

    return 0;
}
